﻿@model eCommerce.BackOffice.ViewModels.OrderReportsViewModel

@{
    ViewBag.Title = "Ventas en carrito";
    Layout = "~/Views/Shared/_ListLayout.cshtml";
}

<style>
    #loadingDiv {
        position: fixed;
        top: 0px;
        right: 0px;
        width: 100%;
        height: 100%;
        background-color: #666;
        background-image: url('/Content/assets/images/AjaxLoader.gif');
        background-repeat: no-repeat;
        background-position: center;
        z-index: 10000000;
        opacity: 0.4;
        filter: alpha(opacity=40); /* For IE8 and earlier */
        display: none;
    }
    .table tbody tr.selected {
        background: #407dbf;
        color: #fff;
    }
    .table tbody tr:hover {
        background: #407dbf;
        color: #fff;
    }
</style>

<div class="page-content padding-30 container-fluid">
    <div class="row">
        <div class="form-group col-md-2 col-xs-6">
            <label class="control-label">Fecha desde:</label>
            <div class="input-group">
                <span class="input-group-addon"><i class="icon wb-calendar" aria-hidden="true"></i></span>
                <input type="text" class="form-control DateInput" id="fromDate" placeholder="Desde" value="@Model.FromDate" />
            </div>
        </div>
        <div class="form-group col-md-2 col-xs-6">
            <label class="control-label">Fecha hasta:</label>
            <div class="input-group">
                <span class="input-group-addon"><i class="icon wb-calendar" aria-hidden="true"></i></span>
                <input type="text" class="form-control DateInput" id="toDate" placeholder="Hasta" value="@Model.ToDate" />
            </div>
        </div>

        <div class="col-md-2 col-xs-12 margin-bottom-15">
            <label class="control-label hidden-xs">&nbsp;</label>
            <button type="button" class="btn btn-outline btn-primary" onclick="getInCartOrders()" style="width:100%;">CONSULTAR</button>
        </div>

        <div class="col-md-2 col-xs-12 margin-bottom-15">
            <label class="control-label hidden-xs">&nbsp;</label>
            <button type="button" class="btn btn-outline btn-primary" onclick="ValidateMassiveMailSend()" style="width:100%;"><i class="icon fa-envelope-o" aria-hidden="true"></i>ENVÍO MASIVO</button>
        </div>
        <div class="col-md-2 col-xs-12 margin-bottom-15">
            <label class="control-label hidden-xs">&nbsp;</label>
            <button type="button" class="btn btn-outline btn-primary" onclick="SelectAll()" style="width:100%;"><i class="fa fa-check" aria-hidden="true"></i>SELECCIONAR TODOS</button>
        </div>

    </div>

    <div class="row" id="data" style="padding:15px;"></div>



</div>

<div id="loadingDiv"></div>

@section scripts{

    <script>

        $('body').on('click', '.js-tr', function () {

            debugger;

            var id = $(this).data('customer-id');
            var index = $.inArray(id, selected);

            if (index === -1) {
                selected.push(id);
            } else {
                selected.splice(index, 1);
            }

            $(this).toggleClass('selected');

        });

        function ValidateMassiveMailSend() {

            if (selected.length > 0) {
                fMassiveSendMailDialog(selected);
            }
            else {
                fNoSelectedMailDialog();
            }
        }

        function fMassiveSendMailDialog(selected) {

            swal({
                title: "Push de venta masivo",
                text: "Esta seguro que desea enviar el mail de push de venta a " + selected.length + " cliente(s)?",
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: '#F26A54',
                confirmButtonText: 'Sí, deseo enviarlo',
                cancelButtonText: 'No',
                closeOnConfirm: false,
                closeOnCancel: true
            },
            function (isConfirm) {
                if (isConfirm) {
                    fSendMassiveMail(selected);

                }
            });

        }

        function SelectAll() {
            $('tbody tr').each(function () {
                $(this).click();
            });
        }

        function fSendMassiveMail(selected) {
            debugger;
            $("#loadingDiv").show();
            $.ajax({
                url: "/Orders/SendMassivePushEmail",
                type: "POST",
                data: { CustomerIds: selected },
                success: function (data) {
                    debugger;
                    if (data == '') {
                        $("#loadingDiv").hide();
                        swal("Enviado!", "", "success");
                    }
                    else {
                        $("#loadingDiv").hide();
                        alert("Hubo un error");
                    }
                }
            });
        }

        function fNoSelectedMailDialog() {

            swal({
                title: "No hay clientes seleccionados",
                text: "Por favor seleccione al menos un cliente",
                type: "warning",
                confirmButtonColor: '#F26A54',
                confirmButtonText: 'Ok',
                closeOnConfirm: true,
            });

        }

        function SendMail(elem) {

            debugger;
            var closestTR = elem.closest('tr');
            var customeremail = closestTR.data('customer-email');
            fSendMailDialog(customeremail);
        }


        function fSendMailDialog(customerEmail) {

            swal({
                title: "Push de venta",
                text: "Esta seguro que desea enviar el mail de push de venta al cliente " + customerEmail + " ?",
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: '#F26A54',
                confirmButtonText: 'Sí, deseo enviarlo',
                cancelButtonText: 'No',
                closeOnConfirm: false,
                closeOnCancel: true
            },
            function (isConfirm) {
                if (isConfirm) {
                    fSendMail(customerEmail);
                }
            });

        }

        var selected = [];

        $(document).ready(function () {
            $('.DateInput').datepicker({
                format: "dd/mm/yyyy",
                language: "es",
                autoclose: true,
                todayHighlight: true
            });
            getInCartOrders();
        });

        function getInCartOrders() {
            if ($('#fromDate').val() != null && $('#fromDate').val() != "" && $('#toDate').val() != null && $('#toDate').val() != "" && moment($('#toDate').val(), "DD/MM/YYYY") < moment($('#fromDate').val(), "DD/MM/YYYY")) {
                toastr.warning("Ingrese una fecha desde menor a fecha hasta.");
            }
            else {
                $("#loadingDiv").show();
                $.ajax({
                    url: "/Orders/GetOrdersInCart",
                    data: { from: $('#fromDate').val(), to: $('#toDate').val() },
                    method: "GET",
                    success: function (result) {
                        $("#loadingDiv").hide();
                        if (result != "") {
                            $('#data').html(result);
                            $('.table-ordersincart').DataTable();
                        }
                        //BindSendMail();
                    },
                    error: function (request, status, error) {
                        $("#loadingDiv").hide();
                        $(".error-message h2").text("Se produjo un error al consultar los datos");
                    }
                });
            }
        }

        function SendMail(elem) {

            //$('.js-sendpushmail').unbind().click(function () {

                var closestTR = elem.closest('tr');
                var customeremail = closestTR.data('customer-email');
                fSendMailDialog(customeremail);

            //});
        }


        function fSendMailDialog(customerEmail) {

            swal({
                title: "Push de venta",
                text: "Esta seguro que desea enviar el mail de push de venta al cliente " + customerEmail + " ?",
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: '#F26A54',
                confirmButtonText: 'Sí, deseo enviarlo',
                cancelButtonText: 'No',
                closeOnConfirm: false,
                closeOnCancel: true
            },
            function (isConfirm) {
                if (isConfirm) {
                    fSendMail(customerEmail);
                }
            });

        }

        function fSendMail(customerEmail) {
            $.ajax({
                url: "/Orders/SendPushEmail",
                type: "GET",
                data: { CustomerEmail: customerEmail },
                success: function (data) {
                    if (data != '') {
                        swal("Enviado!", "", "success");
                        UpdateCartPushDate(data);
                    }
                }
            });
        }

        function UpdateCartPushDate(Id) {

            var customerId = parseInt(Id);
            $.ajax({
                url: "/Orders/GetCustomerPushDate",
                type: "GET",
                data: { CustomerId: customerId },
                success: function (data) {
                    if (data != null) {
                        var tr = $('[data-customer-id=' + customerId + ']');
                        tr.find('.js-cart-push-date').text(data);
                    }
                }
            });

        }

    </script>



}